
import math
import VISI

# ***************************************************
# ********            VCYC Compass rules            ********	 
# ***************************************************

# -------------------------------------------------------------
# RULE DEFINITION EXAMPLE - START
# -------------------------------------------------------------
# The following is an example of the format which is manadatory to follow when writing new rules for the "Compass Technology"
# Please remember that the indentation, the naming convention and the standard is very important and has to be respected.

def CALC_Prefix_VariableName_Index(Variable1,Variable2,Variable3):
# Formula description
	if(Variable1==0):
		number=Variable2+Variable3
		return number
	else:
		return Variable2

# 	CALC_ 	          = This is a standard name which is mandatory when defining a calculation formula
# 	Prefix_ 	          = This is the variable prefix which defines the variables group (eg: V2AX_; V3AX_; V2HS_; VCYC_)
# 	VariableName_         = This is the actual name of the variable which will be used to link the formula to the right field
#	Index			= This is an index number starting with 0 (zero) this number is necessary to allow more rules to be set for the same variable
#	Formula description   = This is a comment which has to be locate right after the "def statement" and that describes the meaning of the formula. This comment will be displayed in the UI
#	Variable1/2/3/...	= This is the list of the neded variables for the definition of the formula.

# NOTE: When an operation variable is spelt correctly in the python script it should appear highlighted in blue and in bold characters

# -------------------------------------------------------------
# RULE DEFINITION EXAMPLE - END
# -------------------------------------------------------------

def CALC_DisableCMP_0(Fea_TaperAngle):
# Disables in the countesink cycle the sinking operation if the Fea_TaperAngle is smaller than 60 degree (Max August '09)
	if(Fea_TaperAngle <60.0):
		return 1
	else:
		return 0
# ------------------------------------------------------------------

def CALC_ToolRounding_0(Variable):
# Rounds the value to the closest half decimal(Max August '09)
	number = round(Variable*2)/2
	return number
# ------------------------------------------------------------------
def CALC_VCYC_Depth_0(Fea_SubType,Fea_Depth,Tool_Diameter,Tool_TipAngle,VCYC_Depth,Fea_MachinableDepth,Fea_TotalStartPositionZ,Fea_StartPositionZ):
# Drilling depth calculation formulas (Max August '09)
	if(Fea_SubType==0):
		return Fea_Depth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
	elif(Fea_SubType==1):
		number=Fea_Depth+((Tool_Diameter/2)/(math.tan(math.radians((Tool_TipAngle/2)))))+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))+3
		return number 
	elif(Fea_SubType==4):
		return Fea_MachinableDepth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
	else:
		return Fea_Depth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
# ------------------------------------------------------------------
def CALC_VCYC_Depth_1(Fea_SubType,Fea_ThreadDepth,VCYC_Depth,Fea_TotalStartPositionZ,Fea_StartPositionZ,Fea_Pitch):
# Tapping depth calculation formulas (Max August '09)
	if(Fea_SubType==1):
		return Fea_ThreadDepth+(4*Fea_Pitch)+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
	else:
		return Fea_ThreadDepth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
# ------------------------------------------------------------------
def CALC_VCYC_Depth_2(Fea_Length,Tool_TipAngle,VCYC_Depth,Fea_ThreadDiam):
# Center drill depth calculation formulas to achieve a mark diameter of (Fea_Length or Fea_ThreadDiam +2mm) (Max August '09)
	if(Fea_ThreadDiam==0.0):
		number=(((Fea_Length+2)/2)/(math.tan(math.radians((Tool_TipAngle/2)))))
		return number
	else:
		number=(((Fea_ThreadDiam+2)/2)/(math.tan(math.radians((Tool_TipAngle/2)))))
		return number
# ------------------------------------------------------------------
def CALC_VCYC_Depth_3(Fea_SubType,Fea_Depth,VCYC_Depth,Fea_TotalStartPositionZ,Fea_StartPositionZ):
# Reaming depth calculation formulas (Max August '09)
	if(Fea_SubType==1):
		return Fea_Depth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))+3
	else:
		return Fea_Depth+(math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ))
# -------------------------------------------------------------
def CALC_VCYC_StartingZ_0(Fea_TotalStartPositionZ,Fea_StartPositionZ,VCYC_StartingZ):
# Starting point calculation formula to mantain the operation starting point consistent with the step starting point (Max August '09)
	number=math.fabs(Fea_TotalStartPositionZ-Fea_StartPositionZ)
	return number
# ------------------------------------------------------------------	
def CALC_VCYC_Tool_0(Fea_Length):
# Calculates the tool diameter for counter sunk (Max August '09)
	if (Fea_Length<18.0):
		return 20.0
	return 50.0



